From 32a4fa18e164a4ac1f4cbbba8644cf74892cc4ba Mon Sep 17 00:00:00 2001
From: Natanael Copa <ncopa@alpinelinux.org>
Date: Tue, 8 Nov 2022 12:27:59 +0100
Subject: [PATCH] init: load keyboard drivers before singlemode shell

fixes https://gitlab.alpinelinux.org/alpine/mkinitfs/-/issues/32
---
 initramfs-init.in | 9 +++++----
 1 file changed, 5 insertions(+), 4 deletions(-)

diff --git a/initramfs-init.in b/initramfs-init.in
index 3450e5e..178d266 100755
--- a/initramfs-init.in
+++ b/initramfs-init.in
@@ -504,15 +504,16 @@ ln -s /proc/mounts /etc/mtab
 
 # check if root=... was set
 if [ -n "$KOPT_root" ]; then
+	# run nlplug-findfs before SINGLEMODE so we load keyboard drivers
+	ebegin "Mounting root"
+	nlplug-findfs $cryptopts -p /sbin/mdev ${KOPT_debug_init:+-d} \
+		$KOPT_root
+
 	if [ "$SINGLEMODE" = "yes" ]; then
 		echo "Entering single mode. Type 'exit' to continue booting."
 		sh
 	fi
 
-	ebegin "Mounting root"
-	nlplug-findfs $cryptopts -p /sbin/mdev ${KOPT_debug_init:+-d} \
-		$KOPT_root
-
 	if echo "$KOPT_modules $rootfstype" | grep -qw btrfs; then
 		/sbin/btrfs device scan >/dev/null || \
 			echo "Failed to scan devices for btrfs filesystem."
-- 
GitLab

